Skip to content
Back to top
View this page

# pip index

## Usage

Unix/macOS

    python -m pip index versions <package>

Windows

    py -m pip index versions <package>

## Description

Inspect information available from package indexes.

## Options

--platform <platform>

  Only use wheels compatible with <platform>. Defaults to the platform of the running system. Use this option multiple times to specify multiple platforms supported by the target interpreter.

  (environment variable: `PIP_PLATFORM`)

--python-version <python_version>

  The Python interpreter version to use for wheel and “Requires-Python” compatibility checks. Defaults to a version derived from the running interpreter. The version can be specified using up to three dot-separated integers (e.g. “3” for 3.0.0, “3.7” for 3.7.0, or “3.7.3”). A major-minor version can also be given as a string without dots (e.g. “37” for 3.7.0).

  (environment variable: `PIP_PYTHON_VERSION`)

--implementation <implementation>

  Only use wheels compatible with Python implementation <implementation>, e.g. ‘pp’, ‘jy’, ‘cp’, or ‘ip’. If not specified, then the current interpreter implementation is used. Use ‘py’ to force implementation-agnostic wheels.

  (environment variable: `PIP_IMPLEMENTATION`)

--abi <abi>

  Only use wheels compatible with Python abi <abi>, e.g. ‘pypy_41’. If not specified, then the current interpreter abi tag is used. Use this option multiple times to specify multiple abis supported by the target interpreter. Generally you will need to specify --implementation, --platform, and --python-version when using this option.

  (environment variable: `PIP_ABI`)

--ignore-requires-python

  Ignore the Requires-Python information.

  (environment variable: `PIP_IGNORE_REQUIRES_PYTHON`)

--json

  Output data in a machine-readable JSON format.

  (environment variable: `PIP_JSON`)

-i, --index-url <url>

  Base URL of the Python Package Index (default https://pypi.org/simple). This should point to a repository compliant with PEP 503 (the simple repository API) or a local directory laid out in the same format.

  (environment variable: `PIP_INDEX_URL`, `PIP_PYPI_URL`)

--extra-index-url <url>

  Extra URLs of package indexes to use in addition to --index-url. Should follow the same rules as --index-url.

  (environment variable: `PIP_EXTRA_INDEX_URL`)

--no-index

  Ignore package index (only looking at --find-links URLs instead).

  (environment variable: `PIP_NO_INDEX`)

-f, --find-links <url>

  If a URL or path to an html file, then parse for links to archives such as sdist (.tar.gz) or wheel (.whl) files. If a local path or file:// URL that’s a directory, then look for archives in the directory listing. Links to VCS project URLs are not supported.

  (environment variable: `PIP_FIND_LINKS`)

--uploaded-prior-to <datetime_or_duration>

  Only consider packages uploaded prior to the given value. Accepts an ISO 8601 datetime (e.g., ‘2023-01-01T00:00:00Z’, uses local timezone if none specified) or a duration in days (e.g., ‘P3D’ for packages uploaded at least 3 days ago). Only effective when installing from indexes that provide upload-time metadata.

  (environment variable: `PIP_UPLOADED_PRIOR_TO`)

--pre

  Include pre-release and development versions. By default, pip only finds stable versions.

  (environment variable: `PIP_PRE`)

--all-releases <release_control>

  Allow all release types (including pre-releases) for a package. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to allow pre-releases for all packages, “:none:” to empty the set (notice the colons), or one or more package names with commas between them (no colons). Cannot be used with --pre.

  (environment variable: `PIP_ALL_RELEASES`)

--only-final <release_control>

  Only allow final releases (no pre-releases) for a package. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable pre-releases for all packages, “:none:” to empty the set, or one or more package names with commas between them. Cannot be used with --pre.

  (environment variable: `PIP_ONLY_FINAL`)

--no-binary <format_control>

  Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable all binary packages, “:none:” to empty the set (notice the colons), or one or more package names with commas between them (no colons). Note that some packages are tricky to compile and may fail to install when this option is used on them.

  (environment variable: `PIP_NO_BINARY`)

--only-binary <format_control>

  Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either “:all:” to disable all source packages, “:none:” to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

  (environment variable: `PIP_ONLY_BINARY`)

--prefer-binary

  Prefer binary packages over source packages, even if the source packages are newer.

  (environment variable: `PIP_PREFER_BINARY`)

## Examples

1. Search for “peppercorn” versions

   Unix/macOS

       $ python -m pip index versions peppercorn
       peppercorn (0.6)
       Available versions: 0.6, 0.5, 0.4, 0.3, 0.2, 0.1

   Windows

       C:\> py -m pip index peppercorn
       peppercorn (0.6)
       Available versions: 0.6, 0.5, 0.4, 0.3, 0.2, 0.1